; applies various simplifications to the IR 

(in-package "FRONTEND")

; a counter used for uniqueness in various passes
(defparameter +monotonic-counter+ 0)

; get a unique counter value
(defun get-unique-integer ()
  (incf +monotonic-counter+))

; make a node name from a counter value
(defun make-node-name ()
  (concatenate 'string "anonymous" 
	       (princ-to-string (get-unique-integer))))

; name all the anonymous types in the IR
(defun name-anonymous-types (node)
  (unmark-graph node)
  (name-anonymous-helper node)
  (dolist (edge (node-edges node))
    (name-anonymous-types (edge-target edge))))

; helper function for naming anonymous nodes
(defmethod name-anonymous-helper ((node node)))

(defmethod name-anonymous-helper ((node cpp-type))
  (if (equal (cpp-type-name node) "")
    (setf (cpp-type-name node) (make-node-name))))
